'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('./index.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Dropdown = require('../Dropdown');

var _ClearableInput = require('../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

var _TextOverflow = require('../TextOverflow');

var _TextOverflow2 = _interopRequireDefault(_TextOverflow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var AutoComplete = (function (_Component) {
  (0, _inherits3.default)(AutoComplete, _Component);

  function AutoComplete(props) {
    (0, _classCallCheck3.default)(this, AutoComplete);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(AutoComplete).call(this));

    _this.state = {
      open: false,
      index: -1,
      result: props.source,
      value: props.defaultValue || props.value || ''
    };
    return _this;
  }

  (0, _createClass3.default)(AutoComplete, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({ value: nextProps.value });
      'source' in nextProps && this.setState({ result: nextProps.source });
    }
  }, {
    key: 'handleInput',
    value: function handleInput(value) {
      this.lastValue = value;
      var state = { value: value };
      if (!value) {
        state.open = true;
        state.result = this.props.source;
        this.setState(state);
      } else {
        // reset tab index
        state.index = -1;
        state.result = this.props.source.filter(function (item) {
          return item.indexOf(value) > -1;
        });
        state.open = !!state.result.length;
        this.setState(state);
      }
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(value) {
      this.setState({
        value: value,
        open: false
      });
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      var _state = this.state;
      var open = _state.open;
      var result = _state.result;

      if (open) {
        var input = e.target;
        var key = e.key;
        var index = this.state.index;

        if (key === 'ArrowDown' || key === 'ArrowUp') {
          if (key === 'ArrowDown') {
            if (index === result.length - 1) index = -1;else index++;
          }
          if (key === 'ArrowUp') {
            e.preventDefault();
            if (index === -1) index = result.length - 1;else index--;
          }
          this.setState({
            index: index,
            value: result[index] || this.lastValue
          });
        }
        if (key === 'Enter') {
          this.handleSelect(result[index]);
          input.blur();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state2 = this.state;
      var open = _state2.open;
      var index = _state2.index;
      var result = _state2.result;
      var value = _state2.value;
      var _props = this.props;
      var className = _props.className;
      var source = _props.source;
      var onFocus = _props.onFocus;
      var onKeyDown = _props.onKeyDown;
      var onChange = _props.onChange;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'source', 'onFocus', 'onKeyDown', 'onChange']);

      return _react2.default.createElement(
        _Dropdown.Dropdown,
        {
          open: open,
          aligned: true,
          onToggle: function onToggle(open) {
            return _this2.setState({ open: open });
          }
        },
        _react2.default.createElement(
          _Dropdown.DropdownToggle,
          { className: (0, _classnames2.default)('bfd-auto-complete', className) },
          _react2.default.createElement(_ClearableInput2.default, (0, _extends3.default)({
            value: value,
            onKeyDown: this.handleKeyDown.bind(this),
            onChange: this.handleInput.bind(this)
          }, other))
        ),
        _react2.default.createElement(
          _Dropdown.DropdownMenu,
          { className: 'bfd-auto-complete__popover' },
          _react2.default.createElement(
            'ul',
            { className: 'bfd-auto-complete__result' },
            result.map(function (item, i) {
              return _react2.default.createElement(
                _TextOverflow2.default,
                { key: item },
                _react2.default.createElement(
                  'li',
                  {
                    className: (0, _classnames2.default)({ 'bfd-auto-complete__option--active': index === i }),
                    onClick: _this2.handleSelect.bind(_this2, item)
                  },
                  item
                )
              );
            })
          )
        )
      );
    }
  }]);
  return AutoComplete;
})(_react.Component);

AutoComplete.propTypes = {

  // 待搜索的数据源
  source: _react.PropTypes.array.isRequired,

  // 输入框的值
  value: _react.PropTypes.string,

  // 初始化输入框的值
  defaultValue: _react.PropTypes.string,

  // 输入改变、选择后的回调，参数为当前输入框的值
  onChange: _react.PropTypes.func,

  // 输入框大小，除默认外可选值：sm、lg
  size: _react.PropTypes.string,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 同 input placeholder
  placeholder: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var value = _ref.value;
    var onChange = _ref.onChange;

    if (value && !onChange) {
      return new Error('You provided a `value` prop without an `onChange` handler');
    }
  }
};

exports.default = AutoComplete;