'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

require('./index.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Button = function Button(props) {
  var _classnames;

  var children = props.children;
  var className = props.className;
  var type = props.type;
  var size = props.size;
  var icon = props.icon;
  var circle = props.circle;
  var transparent = props.transparent;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'type', 'size', 'icon', 'circle', 'transparent']);

  var classNames = (0, _classnames3.default)('bfd-btn', (_classnames = {}, (0, _defineProperty3.default)(_classnames, 'bfd-btn--' + type, type), (0, _defineProperty3.default)(_classnames, 'bfd-btn--' + size, size), (0, _defineProperty3.default)(_classnames, 'bfd-btn--circle', circle), (0, _defineProperty3.default)(_classnames, 'bfd-btn--icon', icon && !children), (0, _defineProperty3.default)(_classnames, 'bfd-btn--transparent', transparent), _classnames), className);
  return _react2.default.createElement(
    'button',
    (0, _extends3.default)({ type: 'button', className: classNames }, other),
    icon && _react2.default.createElement(_Icon2.default, { type: icon }),
    children
  );
};

Button.propTypes = {

  // 按钮类型，除默认外可选值: minor / inverse
  type: _react.PropTypes.string,

  // 按钮尺寸，除默认外可选值：sm、lg
  size: _react.PropTypes.string,

  // 按钮图标，支持 fontawaresome 图标
  icon: _react.PropTypes.string,

  // 是否为圆形
  circle: _react.PropTypes.bool,

  // 文字颜色是否继承，背景是否透明
  transparent: _react.PropTypes.bool
};

exports.default = Button;