'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _findAllByType = require('../findAllByType');

var _findAllByType2 = _interopRequireDefault(_findAllByType);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ButtonGroup = (function (_Component) {
  (0, _inherits3.default)(ButtonGroup, _Component);

  function ButtonGroup(props) {
    (0, _classCallCheck3.default)(this, ButtonGroup);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ButtonGroup).call(this, props));

    _this.state = {
      value: 'value' in props ? props.value : props.defaultValue
    };
    return _this;
  }

  (0, _createClass3.default)(ButtonGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({
        value: nextProps.value
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var className = _props.className;
      var children = _props.children;
      var defaultValue = _props.defaultValue;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'children', 'defaultValue']);

      var items = (0, _findAllByType2.default)(children, _Button2.default);
      var buttons = items.map(function (item, index) {
        if (!item) return;
        return _react2.default.cloneElement(item, {
          key: index,
          type: item.props.value == _this2.state.value ? '' : 'minor',
          onClick: function onClick(e) {
            e.stopPropagation();
            _this2.handleClick(item.props.value);
          }
        });
      });
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-button-group', className) }, other),
        buttons
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick(value) {
      this.setState({
        value: value
      });
      this.props.onChange && this.props.onChange(value);
    }
  }]);
  return ButtonGroup;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

ButtonGroup.propTypes = {

  // 当前值
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 同 value，不可控
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 选中事件，参数返回被选中的值
  onChange: _react.PropTypes.func,

  customProp: function customProp(props) {
    if ('value' in props && !props.onChange) {
      return new Error('You provided a `value` prop without an `onClick` handler');
    }
  }
};

exports.default = ButtonGroup;