'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Checkbox = function Checkbox(props) {
  var children = props.children;
  var className = props.className;
  var block = props.block;
  var indeterminate = props.indeterminate;
  var _onClick = props.onClick;
  var value = props.value;
  var checked = props.checked;
  var defaultChecked = props.defaultChecked;
  var onChange = props.onChange;
  var disabled = props.disabled;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'block', 'indeterminate', 'onClick', 'value', 'checked', 'defaultChecked', 'onChange', 'disabled']);

  var inputProps = { value: value, checked: checked, defaultChecked: defaultChecked, onChange: onChange, disabled: disabled };

  var classNames = (0, _classnames2.default)('bfd-checkbox', {
    'bfd-checkbox--disabled': inputProps.disabled,
    'bfd-checkbox--block': block,
    'bfd-checkbox--indeterminate': indeterminate
  }, className);

  return _react2.default.createElement(
    'label',
    (0, _extends3.default)({
      tabIndex: inputProps.disabled ? -1 : 0,
      className: classNames,
      onClick: function onClick(e) {
        if (e.target.tagName === 'INPUT') {
          e.stopPropagation();
        } else {
          _onClick && _onClick(e);
        }
      }
    }, other),
    _react2.default.createElement('input', (0, _extends3.default)({
      type: 'checkbox',
      className: 'bfd-checkbox__input'
    }, inputProps)),
    _react2.default.createElement('span', { className: 'bfd-checkbox__status' }),
    children && _react2.default.createElement(
      'span',
      { className: 'bfd-checkbox__text' },
      children
    )
  );
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */

Checkbox.propTypes = {

  // 值，如果结合 ChecboxGroup 使用，与其选中的值相对应
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 是否选中
  checked: _react.PropTypes.bool,

  // 初始是否选中（不可控）
  defaultChecked: _react.PropTypes.bool,

  // 切换选中后的回调，参数为 event 对象
  onChange: _react.PropTypes.func,

  // 是否半选中状态
  indeterminate: _react.PropTypes.bool,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 是否块级布局
  block: _react.PropTypes.bool,

  customProp: function customProp(_ref) {
    var checked = _ref.checked;
    var onChange = _ref.onChange;

    if (checked && !onChange) {
      return new Error('You provided a `checked` prop without an `onChange` handler');
    }
  }
};

exports.default = Checkbox;