'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _xhr = require('../xhr');

var _xhr2 = _interopRequireDefault(_xhr);

var _Spinner = require('../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Fetch = (function (_Component) {
  (0, _inherits3.default)(Fetch, _Component);

  function Fetch() {
    (0, _classCallCheck3.default)(this, Fetch);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Fetch).call(this));

    _this.stateMap = {
      init: function init() {
        return this.props.url ? null : this.props.children;
      },
      success: function success() {
        return this.props.children;
      },
      loading: function loading() {
        return _react2.default.createElement(
          'div',
          { className: 'bfd-fetch__mask' },
          _react2.default.createElement(_Spinner2.default, { height: this.props.spinnerHeight, className: 'bfd-fetch__state' })
        );
      },
      error: function error() {
        return _react2.default.createElement(
          'div',
          { className: 'bfd-fetch__mask' },
          _react2.default.createElement(
            'div',
            { className: 'bfd-fetch__state bfd-fetch__state-error' },
            this.state.msg
          )
        );
      }
    };

    _this.state = {
      xhr: 'init',
      msg: null
    };
    return _this;
  }

  (0, _createClass3.default)(Fetch, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.url && nextProps.url !== (this.props.url || this.url)) {
        this.fetch(nextProps.url);
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.url && this.fetch(this.props.url);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      this.handleSuccess = this.handleError = function () {};
    }
  }, {
    key: 'fetch',
    value: function fetch(url, callback) {
      var _this2 = this;

      this.url = url;
      this.timer = this.lazyShowLoading();
      setTimeout(function () {
        (0, _xhr2.default)({
          url: url,
          complete: function complete() {
            clearTimeout(_this2.timer);
          },
          success: function success(res) {
            _this2.setState({ xhr: 'success' });
            callback ? callback(res) : _this2.handleSuccess(res);
          },
          error: _this2.handleError.bind(_this2)
        });
      }, this.props.delay || 0);
    }
  }, {
    key: 'lazyShowLoading',
    value: function lazyShowLoading() {
      var _this3 = this;

      return setTimeout(function () {
        _this3.setState({ xhr: 'loading' });
      }, 150);
    }
  }, {
    key: 'handleSuccess',
    value: function handleSuccess(res) {
      this.props.onSuccess && this.props.onSuccess(res);
    }
  }, {
    key: 'handleError',
    value: function handleError(msg) {
      this.setState({ xhr: 'error', msg: msg });
    }

    /**
     * @public
     * @name reload
     * @param  {function} [callback] 加载成功后的回调，可覆盖 Fetch onSuccess
     * @description 强制 Fetch 重新加载
     */

  }, {
    key: 'reload',
    value: function reload(callback) {
      this.fetch(this.url, callback);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var url = _props.url;
      var onSuccess = _props.onSuccess;
      var defaultHeight = _props.defaultHeight;
      var delay = _props.delay;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'url', 'onSuccess', 'defaultHeight', 'delay']);

      if (defaultHeight) {
        other.style = (0, _assign2.default)(other.style || {}, {
          minHeight: defaultHeight + 'px'
        });
      }
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-fetch', className) }, other),
        this.stateMap[this.state.xhr].call(this)
      );
    }
  }]);
  return Fetch;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

Fetch.propTypes = {

  // 数据源 URL，内部调用 xhr 模块
  url: _react.PropTypes.string,

  // 成功后的回调，参数为返回的数据。error 时会直接显示在对应的容器内
  onSuccess: _react.PropTypes.func,

  // 默认高度，单位像素
  defaultHeight: _react.PropTypes.number,

  // 加载动画高度，默认 30px，可根据场景更改大小
  spinnerHeight: _react.PropTypes.number,

  // 请求延迟，单位毫秒。测试使用
  delay: _react.PropTypes.number
};

exports.default = Fetch;