'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ClearableInput = require('../../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormInput = function FormInput(props, context) {
  var children = props.children;
  var className = props.className;
  var onChange = props.onChange;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'onChange']);
  var form = context.form;
  var formItem = context.formItem;

  other.value = form.getItemValue(formItem);
  other.onChange = function (value) {
    form.setItemValue(formItem, value);
    onChange && onChange(value);
  };
  return _react2.default.createElement(_ClearableInput2.default, (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-form-input', className) }, other));
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */

FormInput.contextTypes = {
  form: _react.PropTypes.object.isRequired,
  formItem: _react.PropTypes.object.isRequired
};

exports.default = FormInput;