'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Spinner = require('../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var FormSubmit = (function (_Component) {
  (0, _inherits3.default)(FormSubmit, _Component);

  function FormSubmit(props, context) {
    (0, _classCallCheck3.default)(this, FormSubmit);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(FormSubmit).call(this));

    var form = context.form;

    form.submit = _this;
    _this.state = {
      process: false
    };
    return _this;
  }

  (0, _createClass3.default)(FormSubmit, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      this.toggleProcess = function () {};
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      var onClick = this.props.onClick;
      var form = this.context.form;

      onClick && onClick();
      if (form.props.onSubmit) {
        form.props.onSubmit(form.state.data);
      } else {
        form.save();
      }
    }

    /**
     * @public
     * @name toggleProcess
     * @param  {boolean} process 是否切换到处理中模式
     * @description 控制按钮状态是否为处理中，用于表单提交成功前的等待提醒，
     * 调用 Form save 方法且表单验证通过后自动调用该接口
     */

  }, {
    key: 'toggleProcess',
    value: function toggleProcess(process) {
      var _this2 = this;

      clearTimeout(this.timer);
      this.timer = setTimeout(function () {
        _this2.setState({ process: process });
      }, process ? 150 : 0);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var onClick = _props.onClick;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'onClick']);
      var process = this.state.process;
      var form = this.context.form;

      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({
          style: { marginLeft: form.props.labelWidth + 'px' },
          className: (0, _classnames2.default)('bfd-form-submit', className),
          onClick: this.handleClick.bind(this),
          disabled: process
        }, other),
        process ? _react2.default.createElement(_Spinner2.default, { height: 20 }) : children
      );
    }
  }]);
  return FormSubmit;
})(_react.Component);

FormSubmit.contextTypes = {
  form: _react.PropTypes.object
};

exports.default = FormSubmit;