'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var NavItem = (function (_Component) {
  (0, _inherits3.default)(NavItem, _Component);

  function NavItem(props) {
    (0, _classCallCheck3.default)(this, NavItem);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NavItem).call(this));

    _this.state = {
      open: props.defaultOpen || false
    };
    return _this;
  }

  (0, _createClass3.default)(NavItem, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var href = this.getHref(this.props);
      var active = this.isActive(this.props, href);
      var state = { href: href, active: active };
      if (this.props.children && active) {
        state.open = true;
      }
      this.setState(state);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var href = this.getHref(nextProps);
      var active = this.isActive(nextProps, href);
      this.setState({ href: href, active: active });
    }
  }, {
    key: 'getHref',
    value: function getHref(props) {
      var href = props.href;
      if (props.blank) return href;
      if (!props.index && !href) return '';
      var baseURL = this.context.nav.props.href || '';
      href = baseURL + '/' + (href || '');
      return href.replace(/\/+/g, '/').replace(/(.+)\/$/, '$1');
    }
  }, {
    key: 'isActive',
    value: function isActive(props, href) {
      if (props.index) {
        return href === (location.pathname || '/');
      } else {
        return href && new RegExp(href + '(?=/|$|\\?|#)').test(location.href);
      }
    }
  }, {
    key: 'toggle',
    value: function toggle(e) {
      e.preventDefault();
      this.setState({ open: !this.state.open });
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      this.props.onClick && this.props.onClick(e);
      !this.props.children && this.context.nav.handleItemClick(this.props, e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state;
      var open = _state.open;
      var href = _state.href;
      var active = _state.active;
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var index = _props.index;
      var defaultOpen = _props.defaultOpen;
      var icon = _props.icon;
      var title = _props.title;
      var blank = _props.blank;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'index', 'defaultOpen', 'icon', 'title', 'blank']);

      delete other.href;

      var NavIcon = icon && _react2.default.createElement(_Icon2.default, { type: icon, className: 'bfd-nav__item-icon' });
      var Toggle = children && _react2.default.createElement(_Icon2.default, { type: 'caret-right', className: 'bfd-nav__item-toggle' });

      var Item = undefined;
      if (children) {
        Item = _react2.default.createElement(
          'a',
          { href: href, onClick: this.toggle.bind(this) },
          NavIcon,
          title,
          Toggle
        );
      } else if (blank) {
        Item = _react2.default.createElement(
          'a',
          { href: href, target: '_blank' },
          NavIcon,
          title,
          Toggle
        );
      } else {
        Item = _react2.default.createElement(
          _reactRouter.Link,
          { to: href },
          NavIcon,
          title,
          Toggle
        );
      }

      var classNames = (0, _classnames2.default)('bfd-nav__item', {
        'bfd-nav__item--open': open,
        'bfd-nav__item--active': active
      }, className);

      // 收起状态时不再渲染子节点
      return _react2.default.createElement(
        'li',
        (0, _extends3.default)({
          onClick: this.handleClick.bind(this),
          className: classNames
        }, other),
        Item,
        open && children && _react2.default.createElement(
          'ul',
          null,
          children
        )
      );
    }
  }]);
  return NavItem;
})(_react.Component);

NavItem.contextTypes = {
  nav: _react.PropTypes.object
};

NavItem.propTypes = {

  index: _react.PropTypes.bool,

  // 当前菜单 href，非叶子节点也需要指定，与路由对应
  href: _react.PropTypes.string,

  // 菜单图标，参考 Icon 组件 type 属性
  icon: _react.PropTypes.string,

  // 菜单标题
  title: _react.PropTypes.string,

  // 初始化是否展开（不可控），用于非叶子节点
  defaultOpen: _react.PropTypes.bool,

  // 是否新窗口打开
  blank: _react.PropTypes.bool
};

exports.default = NavItem;