'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _shouldComponentUpdate = require('../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Percentage = (function (_Component) {
  (0, _inherits3.default)(Percentage, _Component);

  function Percentage() {
    (0, _classCallCheck3.default)(this, Percentage);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Percentage).call(this));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.state = {};
    return _this;
  }

  (0, _createClass3.default)(Percentage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var $root = (0, _reactDom.findDOMNode)(this);
      var width = this.props.width || $root && $root.offsetWidth;
      if (width) {
        this.setState({ size: width });
      } else {
        (0, _invariant2.default)(false, 'The container width for `Percentage` is undefined, Check the width of `Percentage`.');
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.animate();
    }
  }, {
    key: 'animate',
    value: function animate() {
      var _this2 = this;

      var percent = this.props.percent;
      var _refs = this.refs;
      var foreCircle = _refs.foreCircle;
      var text = _refs.text;

      var dashOffset = this.dash * percent / 100;
      var duration = 800;
      var start = null;
      var step = function step(timestrap) {
        if (!start) start = timestrap;
        var progress = timestrap - start;
        var scale = Math.pow(progress / duration, 3);
        foreCircle.style.strokeDashoffset = _this2.dash - dashOffset * scale;
        text.textContent = Math.round(percent * scale) + '%';
        if (progress < duration) {
          window.requestAnimationFrame(step);
        }
      };
      window.requestAnimationFrame(step);
    }
  }, {
    key: 'renderSVG',
    value: function renderSVG() {
      var size = this.state.size;

      if (!size) return null;

      var _props = this.props;
      var percent = _props.percent;
      var foreColor = _props.foreColor;
      var backColor = _props.backColor;
      var textColor = _props.textColor;

      var strokeWidth = size / 20;
      var radius = size / 2 - strokeWidth / 2;
      var fontSize = size * .25;
      var shareProps = {
        r: radius,
        fill: 'none',
        strokeWidth: strokeWidth,
        cx: size / 2,
        cy: size / 2
      };
      this.dash = Math.PI * radius * 2;
      return _react2.default.createElement(
        'svg',
        { width: size, height: size },
        _react2.default.createElement('circle', (0, _extends3.default)({ stroke: backColor || '#f5f5f5' }, shareProps)),
        _react2.default.createElement('circle', (0, _extends3.default)({
          ref: 'foreCircle',
          stroke: foreColor || '@primary-color-deep',
          strokeLinecap: 'round',
          strokeDasharray: this.dash,
          style: { strokeDashoffset: this.dash }
        }, shareProps)),
        _react2.default.createElement(
          'text',
          {
            ref: 'text',
            textAnchor: 'middle',
            fontSize: fontSize,
            fill: textColor || foreColor || '@primary-color-deep',
            x: size / 2,
            y: size / 2,
            dy: '.3em'
          },
          percent + '%'
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var className = _props2.className;
      var width = _props2.width;
      var percent = _props2.percent;
      var foreColor = _props2.foreColor;
      var backColor = _props2.backColor;
      var textColor = _props2.textColor;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['className', 'width', 'percent', 'foreColor', 'backColor', 'textColor']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-percentage', className) }, other),
        this.renderSVG()
      );
    }
  }]);
  return Percentage;
})(_react.Component);

Percentage.propTypes = {

  // 宽度，单位像素，如果不指定，则按父元素内容宽度自适应。也可以通过 css 控制
  width: _react.PropTypes.number,

  // 百分比数值
  percent: _react.PropTypes.number.isRequired,

  // 前景色，默认主色调颜色
  foreColor: _react.PropTypes.string,

  // 背景色，默认 #f5f5f5
  backColor: _react.PropTypes.string,

  // 文字颜色，默认主色调颜色
  textColor: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var percent = _ref.percent;

    if (percent < 0 || percent > 100) {
      return new Error('`percent` should in domain [0, 100]');
    }
  }
};

exports.default = Percentage;