'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _classlist2 = require('classlist');

var _classlist3 = _interopRequireDefault(_classlist2);

var _CoordinateFactory3 = require('./CoordinateFactory');

var _CoordinateFactory4 = _interopRequireDefault(_CoordinateFactory3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PopoverContent = (function (_Component) {
  (0, _inherits3.default)(PopoverContent, _Component);

  function PopoverContent() {
    (0, _classCallCheck3.default)(this, PopoverContent);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(PopoverContent).apply(this, arguments));
  }

  (0, _createClass3.default)(PopoverContent, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        popoverContent: this
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setPosition();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.setPosition();
    }
  }, {
    key: 'setPosition',
    value: function setPosition() {
      var _classnames;

      var _props = this.props;
      var triggerNode = _props.triggerNode;
      var direction = _props.direction;
      var align = _props.align;

      var rootNode = _reactDom2.default.findDOMNode(this);
      rootNode.style.display = 'block';

      // Prevent accumulation
      if (this.positionClassNames) {
        var _classlist;

        (_classlist = (0, _classlist3.default)(rootNode)).remove.apply(_classlist, (0, _toConsumableArray3.default)(this.positionClassNames.split(' ')));
      }

      var _CoordinateFactory = (0, _CoordinateFactory4.default)(triggerNode, rootNode, direction, align);

      var _CoordinateFactory2 = (0, _slicedToArray3.default)(_CoordinateFactory, 2);

      var computedDirection = _CoordinateFactory2[0];
      var computedAlign = _CoordinateFactory2[1];

      this.positionClassNames = (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, 'bfd-popover--' + computedDirection, true), (0, _defineProperty3.default)(_classnames, 'bfd-popover--align-' + computedAlign, !!computedAlign), _classnames));
      (0, _classlist3.default)(rootNode).add(this.positionClassNames);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var children = _props2.children;
      var className = _props2.className;
      var triggerNode = _props2.triggerNode;
      var triggerMode = _props2.triggerMode;
      var direction = _props2.direction;
      var align = _props2.align;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['children', 'className', 'triggerNode', 'triggerMode', 'direction', 'align']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames3.default)('bfd-popover', {
            'bfd-popover--animation': triggerMode === 'hover'
          }, className) }, other),
        _react2.default.createElement(
          'div',
          { className: 'bfd-popover__content' },
          children
        )
      );
    }
  }]);
  return PopoverContent;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

PopoverContent.childContextTypes = {
  popoverContent: _react.PropTypes.instanceOf(PopoverContent)
};

exports.default = PopoverContent;