'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _PopoverContent = require('./PopoverContent');

var _PopoverContent2 = _interopRequireDefault(_PopoverContent);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.addEventListener('click', function () {
  var openedPopoverInContext = Popover[Popover.OPENED_POPOVER];
  openedPopoverInContext && openedPopoverInContext.close();
}); /**
     * Copyright 2016-present, Baifendian, Inc.
     * All rights reserved.
     *
     * This source code is licensed under the BSD-style license found in the
     * LICENSE file in the root directory of this source tree. An additional grant
     * of patent rights can be found in the PATENTS file in the same directory.
     */

var Popover = (function (_Component) {
  (0, _inherits3.default)(Popover, _Component);

  function Popover(props) {
    (0, _classCallCheck3.default)(this, Popover);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Popover).call(this));

    _this.state = {
      open: props.open || false
    };
    return _this;
  }

  (0, _createClass3.default)(Popover, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.open) {
        this.renderContent();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'open' in nextProps && this.setState({ open: nextProps.open });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.open) {
        this.renderContent();
      } else {
        if (prevState.open) {
          _reactDom2.default.findDOMNode(this.popoverContent).style.display = 'none';
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.containerNode) {
        _reactDom2.default.unmountComponentAtNode(this.containerNode);
        document.body.removeChild(this.containerNode);
      }
      var openedPopoverInContext = this.openedPopoverInContext;

      if (openedPopoverInContext === this) {
        this.openedPopoverInContext = null;
      }
    }

    // 当前 popover 所在的浮层（或全局）的打开的 popover，实现打开唯一性

  }, {
    key: 'open',

    /**
     * @public
     * @name popover.open()
     * @description 打开浮层
     */
    value: function open() {
      var _props = this.props;
      var shouldOpen = _props.shouldOpen;
      var onToggle = _props.onToggle;

      if (!shouldOpen || shouldOpen()) {
        this.setState({ open: true });
        onToggle && onToggle(true);

        var openedPopoverInContext = this.openedPopoverInContext;

        if (openedPopoverInContext && openedPopoverInContext !== this) {
          openedPopoverInContext.close();
        }
        this.openedPopoverInContext = this;
      }
    }

    /**
     * @public
     * @name popover.close()
     * @description 关闭浮层
     */

  }, {
    key: 'close',
    value: function close() {
      if (!this.state.open) return;
      var _props2 = this.props;
      var shouldClose = _props2.shouldClose;
      var onToggle = _props2.onToggle;

      if (!shouldClose || shouldClose()) {
        this.setState({ open: false });
        onToggle && onToggle(false);

        if (this.openedPopoverInContext === this) {
          this.openedPopoverInContext = null;
        }
        this.closeChildOpenedPopover();
      }
    }
  }, {
    key: 'closeChildOpenedPopover',
    value: function closeChildOpenedPopover() {
      var childOpenedPopover = this.popoverContent && this.popoverContent[Popover.OPENED_POPOVER];
      childOpenedPopover && childOpenedPopover.close();
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _this2 = this;

      if (!this.containerNode) {
        this.containerNode = document.createElement('div');
        document.body.appendChild(this.containerNode);
      }
      var triggerNode = _reactDom2.default.findDOMNode(this);

      this.renderContent = function () {
        var _props3 = _this2.props;
        var triggerMode = _props3.triggerMode;
        var content = _props3.content;
        var open = _props3.open;
        var onToggle = _props3.onToggle;
        var shouldOpen = _props3.shouldOpen;
        var shouldClose = _props3.shouldClose;
        var disabled = _props3.disabled;
        var aligned = _props3.aligned;
        var other = (0, _objectWithoutProperties3.default)(_props3, ['triggerMode', 'content', 'open', 'onToggle', 'shouldOpen', 'shouldClose', 'disabled', 'aligned']);

        other.onClick = function (e) {
          e.stopPropagation();
          _this2.closeChildOpenedPopover();
        };
        if (triggerMode === 'hover') {
          other.onMouseEnter = function () {
            clearTimeout(_this2.closeTimer);
          };
          other.onMouseLeave = function () {
            _this2.closeTimer = setTimeout(function () {
              return _this2.close();
            }, Popover.LAZY_DURATION);
          };
        }
        if (aligned) {
          other.style = (0, _assign2.default)(other.style || {}, {
            width: triggerNode.offsetWidth
          });
        }
        _reactDom2.default.render(_react2.default.createElement(
          _PopoverContent2.default,
          (0, _extends3.default)({
            ref: function ref(instance) {
              return _this2.popoverContent = instance;
            },
            triggerNode: triggerNode,
            triggerMode: triggerMode
          }, other),
          content
        ), _this2.containerNode);
      };
      this.renderContent();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props4 = this.props;
      var children = _props4.children;
      var triggerMode = _props4.triggerMode;
      var disabled = _props4.disabled;
      var open = this.state.open;

      var triggerProps = {
        className: (0, _classnames2.default)(children.props.className, 'bfd-popover__trigger', {
          'bfd-popover__trigger--disabled': disabled
        })
      };
      if (!disabled) {
        if (triggerMode === 'hover') {
          triggerProps.onMouseEnter = function () {
            clearTimeout(_this3.closeTimer);
            _this3.openTimer = setTimeout(_this3.open.bind(_this3), Popover.LAZY_DURATION);
            children.props.onMouseEnter && children.props.onMouseEnter();
          };
          triggerProps.onMouseLeave = function () {
            clearTimeout(_this3.openTimer);
            _this3.closeTimer = setTimeout(_this3.close.bind(_this3), Popover.LAZY_DURATION);
            children.props.onMouseLeave && children.props.onMouseLeave();
          };
        } else {
          triggerProps.onClick = function (e) {
            e.stopPropagation();
            _this3[open ? 'close' : 'open']();
            children.props.onClick && children.props.onClick();
          };
        }
      }
      return _react2.default.cloneElement(children, triggerProps);
    }
  }, {
    key: 'openedPopoverInContext',
    get: function get() {
      return (this.context.popoverContent || Popover)[Popover.OPENED_POPOVER];
    },
    set: function set(popover) {
      (this.context.popoverContent || Popover)[Popover.OPENED_POPOVER] = popover;
    }
  }]);
  return Popover;
})(_react.Component);

Popover.LAZY_DURATION = 150;
Popover.OPENED_POPOVER = (0, _symbol2.default)();

Popover.contextTypes = {
  popoverContent: _react.PropTypes.instanceOf(_PopoverContent2.default)
};

Popover.defaultProps = {
  direction: 'up',
  triggerMode: 'hover'
};

Popover.propTypes = {
  children: _react.PropTypes.element.isRequired,
  triggerMode: _react.PropTypes.oneOf(['click', 'hover']),
  content: _react.PropTypes.node,
  direction: _react.PropTypes.oneOf(['up', 'down', 'left', 'right']),
  align: _react.PropTypes.oneOf(['top', 'right', 'bottom', 'left', 'middle']),
  open: _react.PropTypes.bool,
  onToggle: _react.PropTypes.func,
  shouldOpen: _react.PropTypes.func,
  shouldClose: _react.PropTypes.func,
  disabled: _react.PropTypes.bool,
  aligned: _react.PropTypes.bool
};

exports.default = Popover;