'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _controlled = require('../_shared/propValidator/controlled');

var _controlled2 = _interopRequireDefault(_controlled);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _ClearableInput = require('../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var SearchInput = (function (_Component) {
  (0, _inherits3.default)(SearchInput, _Component);

  function SearchInput(props) {
    (0, _classCallCheck3.default)(this, SearchInput);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SearchInput).call(this));

    _this.state = {
      value: 'value' in props ? props.value : props.defaultValue
    };
    return _this;
  }

  (0, _createClass3.default)(SearchInput, [{
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({ value: value });
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'handleSearch',
    value: function handleSearch() {
      this.props.onSearch && this.props.onSearch(this.state.value);
    }
  }, {
    key: 'handleKeyUp',
    value: function handleKeyUp(e) {
      e.key === 'Enter' && this.handleSearch();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var label = _props.label;
      var size = _props.size;
      var defaultValue = _props.defaultValue;
      var onSearch = _props.onSearch;
      var onChange = _props.onChange;
      var placeholder = _props.placeholder;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'label', 'size', 'defaultValue', 'onSearch', 'onChange', 'placeholder']);
      var value = this.state.value;

      delete other.value;
      var width = this.props.width || '300px';

      var inputProps = { value: value, size: size, placeholder: placeholder };

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-search_input', className) }, other),
        _react2.default.createElement(_ClearableInput2.default, (0, _extends3.default)({
          style: { width: width },
          onKeyUp: this.handleKeyUp.bind(this),
          onChange: this.handleChange.bind(this)
        }, inputProps)),
        _react2.default.createElement(
          _Button2.default,
          { size: size, onClick: this.handleSearch.bind(this), icon: 'search' },
          label
        )
      );
    }
  }]);
  return SearchInput;
})(_react.Component);

SearchInput.defaultProps = {
  label: '搜索'
};

SearchInput.propTypes = {

  // 输入框值
  value: (0, _controlled2.default)(_react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number])),

  // 同 value，不可控
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 搜索框值改变事件，value为搜索框输入值
  onChange: _react.PropTypes.func,

  // 搜索按钮单击事件，value为搜索框输入值
  onSearch: _react.PropTypes.func.isRequired,

  // 搜索按钮名称，默认 `搜索`
  label: _react.PropTypes.string,

  // 搜索框提示信息
  placeholder: _react.PropTypes.string,

  // 输入框高度尺寸，默认中等尺寸
  size: _react.PropTypes.oneOf(['sm', 'lg']),

  // 输入框宽度，默认为300px
  width: _react.PropTypes.string
};

exports.default = SearchInput;