'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _shouldComponentUpdate = require('../../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _dataFilter = require('../../_shared/dataFilter');

var _dataFilter2 = _interopRequireDefault(_dataFilter);

var _TextOverflow = require('../../TextOverflow');

var _TextOverflow2 = _interopRequireDefault(_TextOverflow);

var _ClearableInput = require('../../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

var _SelectDropdown = require('../../SelectDropdown');

var _SelectDropdown2 = _interopRequireDefault(_SelectDropdown);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = (function (_Component) {
  (0, _inherits3.default)(Select, _Component);

  function Select(props) {
    (0, _classCallCheck3.default)(this, Select);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Select).call(this));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.state = {
      data: props.data || [],
      index: -1,
      value: 'value' in props ? props.value : props.defaultValue,
      searchValue: null
    };
    return _this;
  }

  (0, _createClass3.default)(Select, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var state = {
        searchValue: null
      };
      'value' in nextProps && (state.value = nextProps.value);
      'data' in nextProps && (state.data = nextProps.data);
      this.setState(state);
    }
  }, {
    key: 'handleLoad',
    value: function handleLoad(data) {
      var url = this.props.url;

      data = (0, _dataFilter2.default)(this, data) || [];
      (0, _invariant2.default)(Array.isArray(data), '`Select` data should be `Array`, check the response of `' + url + '` or the return value of `dataFilter`.');
      this.setState({ data: data });
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(value, item) {
      this.refs.dropdown.close();
      this.setState({ value: value });
      this.props.onChange && this.props.onChange(value, item);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(options, e) {
      var key = e.key;
      var index = this.state.index;

      if (key === 'ArrowDown' || key === 'ArrowUp') {
        if (key === 'ArrowDown') {
          if (index === options.length - 1) index = 0;else index++;
        }
        if (key === 'ArrowUp') {
          e.preventDefault();
          if (index === 0) index = options.length - 1;else index--;
        }
        this.setState({ index: index });
      }
      if (key === 'Enter') {
        var props = options[index].props;
        this.handleSelect(props.value, props.data || props);
      }
    }
  }, {
    key: 'handleSearch',
    value: function handleSearch(searchValue) {
      this.setState({
        searchValue: searchValue,
        index: -1
      });
    }
  }, {
    key: 'handleDropToggle',
    value: function handleDropToggle(open) {
      var _this2 = this;

      this.props.searchable && open && setTimeout(function () {
        _this2.refs.clearableInput.focus();
      }, 0);
    }
  }, {
    key: 'getOptionsWithProps',
    value: function getOptionsWithProps(onMatch) {
      var _this3 = this;

      var _props = this.props;
      var children = _props.children;
      var render = _props.render;
      var defaultOption = _props.defaultOption;

      var res = undefined;
      if (children) {
        res = _react2.default.Children.map(children, this.getOptionWithProps.bind(this, onMatch));
      } else {
        res = this.state.data.map(function (item, i) {
          return _this3.getOptionWithProps(onMatch, render.call(_this3, item, i), i, item);
        });
      }
      if (defaultOption) {
        res.unshift(this.getOptionWithProps(onMatch, defaultOption, -1));
      }
      return res;
    }
  }, {
    key: 'getOptionWithProps',
    value: function getOptionWithProps(onMatch, option, i, dataItem) {
      if (!option) return;
      var _option$props = option.props;
      var value = _option$props.value;
      var children = _option$props.children;

      var selected = false;
      if (this.state.value === value) {
        onMatch && onMatch(children);
        selected = true;
      }
      return _react2.default.cloneElement(option, {
        data: dataItem,
        selected: selected,
        key: i,
        onClick: this.handleSelect.bind(this, value, dataItem || option.props)
      });
    }
  }, {
    key: 'filterBySearchValue',
    value: function filterBySearchValue(options) {
      var searchValue = this.state.searchValue;

      if (!searchValue) return options;
      return options.filter(function (option) {
        var _option$props2 = option.props;
        var value = _option$props2.value;
        var children = _option$props2.children;

        if (!value && value !== 0) return false;
        return children.indexOf(searchValue) !== -1 || String(value).indexOf(searchValue) !== -1;
      });
    }
  }, {
    key: 'shouldSearchable',
    value: function shouldSearchable(options) {
      if (!this.props.searchable) return options;
      var index = this.state.index;

      return options.map(function (option, i) {
        return _react2.default.cloneElement(option, {
          active: index === i
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props2 = this.props;
      var children = _props2.children;
      var className = _props2.className;
      var defaultValue = _props2.defaultValue;
      var onChange = _props2.onChange;
      var data = _props2.data;
      var dataFilter = _props2.dataFilter;
      var defaultOption = _props2.defaultOption;
      var size = _props2.size;
      var placeholder = _props2.placeholder;
      var searchPlaceholder = _props2.searchPlaceholder;
      var searchable = _props2.searchable;
      var noOptionsContent = _props2.noOptionsContent;
      var noMatchingContent = _props2.noMatchingContent;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['children', 'className', 'defaultValue', 'onChange', 'data', 'dataFilter', 'defaultOption', 'size', 'placeholder', 'searchPlaceholder', 'searchable', 'noOptionsContent', 'noMatchingContent']);
      var _state = this.state;
      var value = _state.value;
      var searchValue = _state.searchValue;

      delete other.value;
      delete other.render;

      var title = null;
      var optionsWithProps = this.getOptionsWithProps(function (children) {
        return title = children;
      });
      optionsWithProps = this.filterBySearchValue(optionsWithProps);
      optionsWithProps = this.shouldSearchable(optionsWithProps);

      var classNames = (0, _classnames3.default)('bfd-select', (_classnames = {}, (0, _defineProperty3.default)(_classnames, 'bfd-select--' + size, size), (0, _defineProperty3.default)(_classnames, 'bfd-select--searchable', searchable), _classnames), className);

      if (!title) {
        if (!value && !defaultOption) {
          title = placeholder;
        }
        if (value) {
          title = noMatchingContent;
        }
      }

      var Title = _react2.default.createElement(
        _TextOverflow2.default,
        null,
        _react2.default.createElement(
          'div',
          { className: 'bfd-select__title' },
          title
        )
      );

      return _react2.default.createElement(
        _SelectDropdown2.default,
        (0, _extends3.default)({
          ref: 'dropdown',
          className: classNames,
          title: Title,
          onLoad: this.handleLoad.bind(this),
          hasPropValue: 'value' in this.props || 'defaultValue' in this.props,
          onToggle: this.handleDropToggle.bind(this),
          caret: true
        }, other),
        searchable && _react2.default.createElement(_ClearableInput2.default, {
          ref: 'clearableInput',
          className: 'bfd-select__search-input',
          value: searchValue,
          placeholder: searchPlaceholder,
          onChange: this.handleSearch.bind(this),
          onKeyDown: this.handleKeyDown.bind(this, optionsWithProps)
        }),
        _react2.default.createElement(
          'ul',
          { className: 'bfd-select__options' },
          optionsWithProps && optionsWithProps.length ? optionsWithProps : _react2.default.createElement(
            'li',
            { className: 'bfd-select__option' },
            noOptionsContent
          )
        )
      );
    }
  }]);
  return Select;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

Select.defaultProps = {
  placeholder: '请选择',
  searchPlaceholder: '请输入关键词搜索',
  noOptionsContent: '无选项',
  noMatchingContent: '无匹配选项'
};

Select.propTypes = {

  // 选中的值
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 初始化时选中的值（不可控）
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 切换选择后的回调，function(value, item)，当前数据项或 option.props
  onChange: _react.PropTypes.func,

  // 数据源，结合 render 属性定义 Option 渲染逻辑
  data: _react.PropTypes.array,

  // URL 数据源
  url: _react.PropTypes.string,

  // URL 数据源模式数据过滤，参数为服务器返回的数据，返回处理后的数据
  dataFilter: _react.PropTypes.func,

  // data 或 url 方式时 Option 渲染回调，参数为当前数据和索引，返回一个 Option
  render: _react.PropTypes.func,

  // data 或 url 方式时默认的 Option，通常针对空值时的选项
  defaultOption: _react.PropTypes.element,

  // 无 `value` 且无选项匹配时 Select 显示的内容，默认 `请选择`
  placeholder: _react.PropTypes.string,

  // 是否可搜索，搜索范围为 Option 的 value 和 children
  searchable: _react.PropTypes.bool,

  // 搜索框 placeholder，默认`请输入关键词搜索`
  searchPlaceholder: _react.PropTypes.string,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 尺寸
  size: _react.PropTypes.oneOf(['sm', 'lg']),

  // 最小宽度，默认 160
  minWidth: _react.PropTypes.number,

  // 无 option 时显示的内容，默认`无选项`
  noOptionsContent: _react.PropTypes.string,

  // 有 `value` 但无选项匹配时显示的内容，默认`无匹配选项`
  noMatchingContent: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var value = _ref.value;
    var onChange = _ref.onChange;
    var url = _ref.url;
    var render = _ref.render;

    if (value && !onChange) {
      return new Error('You provided a `value` prop without an `onChange` handler');
    }
    if (url && !render) {
      return new Error('You provided a `url` prop without an `render` handler');
    }
  }
};

exports.default = Select;