'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Dropdown = require('../Dropdown');

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var SelectDropdown = (function (_Component) {
  (0, _inherits3.default)(SelectDropdown, _Component);

  function SelectDropdown() {
    (0, _classCallCheck3.default)(this, SelectDropdown);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SelectDropdown).apply(this, arguments));
  }

  (0, _createClass3.default)(SelectDropdown, [{
    key: 'close',
    value: function close() {
      this.dropdown.close();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var className = _props.className;
      var children = _props.children;
      var title = _props.title;
      var url = _props.url;
      var hasPropValue = _props.hasPropValue;
      var caret = _props.caret;
      var onLoad = _props.onLoad;
      var onToggle = _props.onToggle;
      var minWidth = _props.minWidth;
      var disabled = _props.disabled;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'children', 'title', 'url', 'hasPropValue', 'caret', 'onLoad', 'onToggle', 'minWidth', 'disabled']);

      if (minWidth) {
        other.style = (0, _assign2.default)(other.style || {}, { minWidth: minWidth });
      }

      return _react2.default.createElement(
        _Dropdown.Dropdown,
        {
          aligned: true,
          onToggle: onToggle,
          disabled: disabled,
          ref: function ref(dropdown) {
            return _this2.dropdown = dropdown;
          }
        },
        _react2.default.createElement(
          _Dropdown.DropdownToggle,
          (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-select-dropdown', {
              'bfd-select-dropdown--caretable': caret
            }, className) }, other),
          url && hasPropValue ? _react2.default.createElement(
            _Fetch2.default,
            {
              spinnerHeight: 20,
              defaultHeight: 28,
              url: url,
              onSuccess: onLoad
            },
            title
          ) : title,
          caret && _react2.default.createElement(_Icon2.default, { type: 'caret-down', className: 'bfd-select-dropdown__caret' })
        ),
        _react2.default.createElement(
          _Dropdown.DropdownMenu,
          { className: 'bfd-select-dropdown__popover' },
          url && !hasPropValue ? _react2.default.createElement(
            _Fetch2.default,
            {
              url: url,
              defaultHeight: 30,
              spinnerHeight: 20,
              onSuccess: onLoad
            },
            children
          ) : children
        )
      );
    }
  }]);
  return SelectDropdown;
})(_react.Component);

SelectDropdown.propTypes = {
  title: _react.PropTypes.element.isRequired,
  url: _react.PropTypes.string,
  hasPropValue: _react.PropTypes.bool,
  caret: _react.PropTypes.bool,
  disabled: _react.PropTypes.bool,
  minWidth: _react.PropTypes.number,
  onLoad: _react.PropTypes.func,
  onToggle: _react.PropTypes.func
};

exports.default = SelectDropdown;