'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SubSplitPanel = exports.SplitPanel = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _findAllByType = require('../findAllByType');

var _findAllByType2 = _interopRequireDefault(_findAllByType);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var SubSplitPanel = (function (_Component) {
  (0, _inherits3.default)(SubSplitPanel, _Component);

  function SubSplitPanel(props) {
    (0, _classCallCheck3.default)(this, SubSplitPanel);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SubSplitPanel).call(this, props));
  }

  (0, _createClass3.default)(SubSplitPanel, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var direct = _props.direct;
      var width = _props.width;
      var height = _props.height;
      var onSplit = _props.onSplit;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'direct', 'width', 'height', 'onSplit']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)(className) }, other),
        children
      );
    }
  }]);
  return SubSplitPanel;
})(_react.Component);

var SplitPanel = (function (_Component2) {
  (0, _inherits3.default)(SplitPanel, _Component2);

  function SplitPanel(props) {
    (0, _classCallCheck3.default)(this, SplitPanel);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SplitPanel).call(this, props));

    _this2.width = 0;
    _this2.height = 0;
    _this2.offsetLeft = 0;
    _this2.offsetTop = 0;
    _this2.clientX = 0;
    _this2.clientY = 0;
    _this2.oldSplit = {
      width: 0,
      height: 0,
      width1: 0,
      height1: 0
    };
    _this2.currSplit = {
      width: 0,
      height: 0,
      width1: 0,
      height1: 0
    };
    _this2.down = false;
    _this2.mouseMoveFn = null;
    _this2.mouseUpFn = null;
    return _this2;
  }

  (0, _createClass3.default)(SplitPanel, [{
    key: 'handleMouseDown',
    value: function handleMouseDown(event) {
      event.stopPropagation();
      this.down = true;
      var direct = this.props.direct;
      var line = this.refs.line;
      var BODY = document.body;
      this.clientX = event.clientX;
      this.clientY = event.clientY;
      line.left = line.offsetLeft;
      line.top = line.offsetTop;
      var top = this.refs.top;
      var bottom = this.refs.bottom;
      this.oldSplit.width = parseInt(top.style.width);
      this.oldSplit.height = parseInt(top.style.height);
      this.oldSplit.width1 = parseInt(bottom.style.width);
      this.oldSplit.height1 = parseInt(bottom.style.height);

      if (direct == 'ver') {
        this.mouseMoveFn = this.handleMouseLRMove.bind(this);
      } else {
        this.mouseMoveFn = this.handleMouseUDMove.bind(this);
      }
      this.mouseUpFn = this.handleMouseUp.bind(this);
      BODY.addEventListener('mousemove', this.mouseMoveFn);
      BODY.addEventListener('mouseup', this.mouseUpFn);
    }
  }, {
    key: 'handleMouseUDMove',
    value: function handleMouseUDMove(event) {
      if (!this.down) {
        return;
      }
      var container = this.refs.container;
      var top = this.refs.top;
      var bottom = this.refs.bottom;
      var line = this.refs.line;
      var lineStyle = getComputedStyle(line);
      var scope = line.top + event.clientY - this.clientY;
      var maxScope = container.clientHeight - line.offsetHeight;
      line.style.margin = 0;
      if (scope < 0) {
        scope = 0;
      }
      if (scope > maxScope) {
        scope = maxScope;
      }
      line.style.top = top.style.height = scope + 'px';
      bottom.style.height = container.clientHeight - parseInt(lineStyle.height) - scope + 'px';
      return false;
    }
  }, {
    key: 'handleMouseLRMove',
    value: function handleMouseLRMove(event) {
      if (!this.down) {
        return;
      }
      var container = this.refs.container;
      var top = this.refs.top;
      var bottom = this.refs.bottom;
      var line = this.refs.line;
      var lineStyle = getComputedStyle(line);
      var scope = line.left + event.clientX - this.clientX;
      var maxScope = container.clientWidth - line.offsetWidth;
      line.style.margin = 0;
      if (scope < 0) {
        scope = 0;
      }
      if (scope > maxScope) {
        scope = maxScope;
      }
      line.style.left = top.style.width = scope + 'px';
      bottom.style.width = container.clientWidth - scope - parseInt(lineStyle.width) + 'px';
      return false;
    }
  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp() {
      var direct = this.props.direct;
      var BODY = document.body;
      var top = this.refs.top;
      var bottom = this.refs.bottom;
      this.currSplit.width = parseInt(top.style.width);
      this.currSplit.height = parseInt(top.style.height);
      this.currSplit.width1 = parseInt(bottom.style.width);
      this.currSplit.height1 = parseInt(bottom.style.height);
      if (typeof this.props.onSplit == 'function') {
        var old = this.oldSplit;
        var curr = this.currSplit;
        if (direct == 'ver') {
          (0, _typeof3.default)(this.props.onSplit(old.width, old.width1, curr.width, curr.width1));
        } else {
          (0, _typeof3.default)(this.props.onSplit(old.height, old.height1, curr.height, curr.height1));
        }
      }
      this.down = false;
      BODY.removeEventListener('mousemove', this.mouseMoveFn);
      BODY.removeEventListener('mouseup', this.mouseUpFn);

      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var children = _props2.children;
      var className = _props2.className;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['children', 'className']);

      delete other.direct;
      delete other.onSplit;
      var items = (0, _findAllByType2.default)(children, SubSplitPanel);
      var direct = this.props.direct;
      var lineClassName = direct == 'ver' ? 'bfd-split-panel__verline' : 'bfd-split-panel__horline';
      var topStyle = direct == 'ver' ? {
        float: 'left'
      } : {};
      var bottomStyle = direct == 'ver' ? {
        float: 'right'
      } : {};
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ ref: 'container', className: (0, _classnames2.default)('bfd-split-panel', className) }, other),
        _react2.default.createElement(
          'div',
          { ref: 'top', style: topStyle, className: 'bfd-split-panel--top' },
          items[0]
        ),
        _react2.default.createElement('div', { ref: 'line', className: lineClassName, onMouseDown: this.handleMouseDown.bind(this) }),
        _react2.default.createElement(
          'div',
          { ref: 'bottom', style: bottomStyle, className: 'bfd-split-panel--bottom' },
          items[1]
        )
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var items = (0, _findAllByType2.default)(this.props.children, SubSplitPanel);
      var container = this.refs.container;
      var top = this.refs.top;
      var bottom = this.refs.bottom;
      var line = this.refs.line;
      var style = getComputedStyle(container);
      var lineStyle = getComputedStyle(line);
      var direct = this.props.direct;
      var containerHeight = container.offsetHeight;
      var containerWidth = container.offsetWidth;
      container.style.width = containerWidth + 'px';
      container.style.height = containerHeight + 'px';

      if (direct == 'ver') {
        top.style.height = '100%';
        bottom.style.height = '100%';
        var width = items[0].props.width || containerWidth / 2;
        top.style.width = width + 'px';
        line.style.left = width + 'px';
        bottom.style.width = containerWidth - width - parseInt(lineStyle.width) - parseInt(style.borderWidth) - 1 + 'px';
      } else {
        top.style.width = '100%';
        bottom.style.width = '100%';
        var height = items[0].props.height || containerHeight / 2;
        top.style.height = height + 'px';
        line.style.top = height + 'px';
        bottom.style.height = containerHeight - height - parseInt(lineStyle.height) - parseInt(style.borderWidth) + 'px';
      }
    }
  }]);
  return SplitPanel;
})(_react.Component);

SplitPanel.propTypes = {

  // 分栏方向，分为水平分栏（hor）和垂直分栏（ver）两种
  direct: _react.PropTypes.string.isRequired,

  // 分栏拖动事件，当属性direct=ver，返回四个参数为oldWidth、oldWidth1（代表两栏原宽度）和width1、width2（代表两栏当前宽度），当属性direct=hor，返回四个参数为oldHeight、oldHeight2（代表两栏原高度）和height1、height2（代表两栏当前高度）
  onSplit: _react.PropTypes.func,
  customProp: function customProp(_ref) {
    var direct = _ref.direct;

    if (!direct) {
      return new Error('direct必填属性。');
    }
  }
};

SubSplitPanel.propTypes = {

  // 左栏宽度，当容器属性direct=ver时有效
  width: _react.PropTypes.number,

  // 上栏高度，当容器属性direct=hor时有效
  height: _react.PropTypes.number
};

exports.SplitPanel = SplitPanel;
exports.SubSplitPanel = SubSplitPanel;