'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

/*
 * 默认颜色值
 * create by tenglong.jiang on 2016/4/25
 */

var _class = (function () {
  function _class(type) {
    (0, _classCallCheck3.default)(this, _class);

    this.index = 0;
    this.color = ['#E6EE9C', '#FFAB91', '#EF9A9A', '#9FA8DA', '#80CBC4', '#FFF59D', '#F48FB1', '#90CAF9', '#A5D6A7', '#FCE68D', '#CE93D8', '#81D4FA', '#C5E1A5', '#FFCC80', '#B39DDB', '#80DEEA'];
    this.scope = this.getScope(type);

    if (this.scope) {
      this.index = this.scope.start;
    }
  }

  /*
   * 获取一个颜色值，不在colors范围内。
   * index 索引，可选
   * colors 颜色值数组，返回值color值不能在这个范围值内，可选
   */

  (0, _createClass3.default)(_class, [{
    key: 'getColor',
    value: function getColor(index, colors) {
      index = index || this.index++;
      if (index > this.color.length) {
        var number = index % this.color.length;
        return this.color[number];
      }
      var color = this.color[index];
      if (colors) {
        if (this.valid(color, colors)) {
          this.index++;
          return this.getColor(this.index, colors);
        } else {
          return color;
        }
      } else {
        return color;
      }
    }

    /*
     * 验证color是否在colors数组内存在。
     * color 颜色值
     * colors 颜色值数组
     */

  }, {
    key: 'valid',
    value: function valid(color, colors) {
      if (colors instanceof Array && colors.length > 0) {
        for (var i = 0; i < colors.length; i++) {
          if (color == colors[i]) {
            return true;
          }
        }
      }
      return false;
    }

    /*
     * 获取色系属性
     * scope 色系值 C1 C2 C3 C4
     */

  }, {
    key: 'getScope',
    value: function getScope(scope) {
      if (!scope) {
        return null;
      }
      var colorScope = {
        'C1': {
          default: ['#B39DDB', '#F48FB1'],
          start: 7
        },
        'C2': {
          default: ['#80DEEA', '#90CAF9'],
          start: 8
        },
        'C3': {
          default: ['#A5D6A7', '#E6EE9C'],
          start: 1
        },
        'C4': {
          default: ['#FFAB91', '#FFCC80'],
          start: 14
        }
      };
      scope = scope || 'C2';
      return colorScope[scope] || colorScope['C2'];
    }
  }, {
    key: 'getDefault',
    value: function getDefault(index) {
      if (typeof index === 'undefined') {
        return this.scope.default;
      } else {
        return this.scope ? this.scope.default[index] : null;
      }
    }
  }]);
  return _class;
})();

exports.default = _class;