'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Switch = (function (_Component) {
  (0, _inherits3.default)(Switch, _Component);

  function Switch(props) {
    (0, _classCallCheck3.default)(this, Switch);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Switch).call(this));

    _this.state = {
      on: props.on || props.defaultOn || false
    };
    return _this;
  }

  (0, _createClass3.default)(Switch, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'on' in nextProps && this.setState({ on: nextProps.on });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      e.stopPropagation();
      this.setState({ on: e.target.checked });
      this.props.onChange && this.props.onChange(e.target.checked);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var defaultOn = _props.defaultOn;
      var onChange = _props.onChange;
      var labelOn = _props.labelOn;
      var labelOff = _props.labelOff;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultOn', 'onChange', 'labelOn', 'labelOff']);
      var on = this.state.on;

      delete other.on;

      return _react2.default.createElement(
        'label',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-switch', className) }, other),
        _react2.default.createElement('input', { type: 'checkbox', checked: on, onChange: this.handleChange.bind(this) }),
        _react2.default.createElement(
          'span',
          { className: 'bfd-switch__text' },
          on ? labelOn : labelOff
        )
      );
    }
  }]);
  return Switch;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

Switch.propTypes = {

  // 是否打开
  on: _react.PropTypes.bool,

  // 初始化是否打开（不可控）
  defaultOn: _react.PropTypes.bool,

  // 切换后的回调，参数为是否打开
  onChange: _react.PropTypes.func,

  // 打开状态下显示的内容
  labelOn: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.element]),

  // 关闭状态下显示的内容
  labelOff: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.element]),

  customProp: function customProp(_ref) {
    var on = _ref.on;
    var onChange = _ref.onChange;

    if (on && !onChange) {
      return new Error('You provided a `on` prop without an `onChange` handler');
    }
  }
};

exports.default = Switch;