'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextOverflow = require('../TextOverflow');

var _TextOverflow2 = _interopRequireDefault(_TextOverflow);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var TagList = (function (_Component) {
  (0, _inherits3.default)(TagList, _Component);

  function TagList() {
    (0, _classCallCheck3.default)(this, TagList);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TagList).apply(this, arguments));
  }

  (0, _createClass3.default)(TagList, [{
    key: 'focus',
    value: function focus() {
      this.refs.input.focus();
    }
  }, {
    key: 'blur',
    value: function blur() {
      this.refs.input.blur();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var labels = _props.labels;
      var placeholder = _props.placeholder;
      var inputValue = _props.inputValue;
      var onRemove = _props.onRemove;
      var onInput = _props.onInput;
      var onInputKeyChange = _props.onInputKeyChange;
      var inputable = _props.inputable;
      var disabled = _props.disabled;

      var inputSize = ((labels.length ? inputValue : placeholder) || ' ').replace(/[\u4e00-\u9FA5]/g, '  ').length;

      return _react2.default.createElement(
        'ul',
        { className: 'bfd-tag-list' },
        labels.map(function (item) {
          return _react2.default.createElement(
            'li',
            { key: item.value, className: 'bfd-tag-list__item' },
            _react2.default.createElement(
              _TextOverflow2.default,
              null,
              _react2.default.createElement(
                'span',
                { className: 'bfd-tag-list__label' },
                item.label
              )
            ),
            _react2.default.createElement(_Button2.default, {
              icon: 'remove',
              transparent: true,
              size: 'sm',
              onClick: function onClick(e) {
                e.stopPropagation();
                onRemove(item.value);
              }
            })
          );
        }),
        _react2.default.createElement(
          'li',
          null,
          _react2.default.createElement('input', {
            type: 'text',
            ref: 'input',
            readOnly: !inputable,
            disabled: disabled,
            value: inputValue,
            size: Math.min(inputSize, 45),
            onChange: function onChange(e) {
              return onInput(e.target.value);
            },
            onKeyDown: function onKeyDown(e) {
              return onInputKeyChange(e);
            },
            placeholder: labels.length ? '' : placeholder })
        )
      );
    }
  }]);
  return TagList;
})(_react.Component);

TagList.propTypes = {
  labels: _react.PropTypes.array.isRequired,
  placeholder: _react.PropTypes.string,
  onRemove: _react.PropTypes.func,
  inputable: _react.PropTypes.bool,
  disabled: _react.PropTypes.bool,
  inputValue: _react.PropTypes.string,
  onInput: _react.PropTypes.func,
  onInputKeyChange: _react.PropTypes.func
};

exports.default = TagList;