'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Tooltip = function Tooltip(props) {
  var children = props.children;
  var className = props.className;
  var title = props.title;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'title']);

  return _react2.default.createElement(
    _Popover2.default,
    (0, _extends3.default)({
      className: (0, _classnames2.default)('bfd-tooltip__popover', className),
      content: title
    }, other),
    children
  );
};

Tooltip.defaultProps = {
  triggerMode: 'hover',
  direction: 'up',
  align: 'middle'
};

Tooltip.propTypes = {

  children: _react.PropTypes.element.isRequired,

  // 提示框显示内容，可以是文本字符串，也可以是 React 元素
  title: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.element]),

  // 提示框触发方式，默认 `hover`
  triggerMode: _react.PropTypes.oneOf(['hover', 'click']),

  // 提示框位置方向，默认 `up`
  direction: _react.PropTypes.oneOf(['up', 'down', 'left', 'right']),

  // 提示框对齐方式，默认 `middle`
  align: _react.PropTypes.oneOf(['top', 'right', 'bottom', 'left', 'middle'])
};

exports.default = Tooltip;