'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (validator) {
  var callbackName = arguments.length <= 1 || arguments[1] === undefined ? 'onChange' : arguments[1];

  return function (props, propName, componentName) {
    if (propName in props && !props[callbackName] && !props.disabled) {
      return new Error('You provided a `' + propName + '` prop to `' + componentName + '` without an `' + callbackName + '` handler.');
    }
    return validator.apply(undefined, arguments);
  };
};