'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

// ShadowEqual except function props.
function isEqual(source, target) {
  if (!source) return true;
  return (0, _keys2.default)(source).every(function (key) {
    var isEqual = true;
    var prop = source[key];
    if (typeof prop !== 'function' && target[key] !== source[key]) {
      isEqual = false;
    }
    return isEqual;
  });
}

function shouldComponentUpdate(nextProps, nextState) {
  if (nextProps.children) return true;
  return !(isEqual(nextProps, this.props) && isEqual(nextState, this.state));
}

exports.default = shouldComponentUpdate;